import pygame
from pygame.locals import *
import math
import random

#This file contains constant values used throughout the game code.
def dist(p1, p2):
    dx = p1[0]-p2[0]
    dy = p1[1]-p2[1]
    return math.sqrt(dx*dx+dy*dy)

#This is used for creating config file paths
#IMPORTANT: CHANGE THIS TO CORRESPOND TO YOUR GAME.
#NOT CHANGING THIS MIGHT LEAD TO CONFLICTING CONFIG FILES.
GAME_NAME_SHORT = "gather"

#Game screen dimensions used by functions in util.py
SCREEN_WIDTH = 640
SCREEN_HEIGHT = 480
HALF_SCREEN_WIDTH =  SCREEN_WIDTH / 2
HALF_SCREEN_HEIGHT =  SCREEN_HEIGHT / 2
WORLD_WIDTH = 1280
WORLD_HEIGHT = 1024

#
#These are used by functions in util.py:
#
FPS = 30

#For the fade_to_black function.
FADE_STATE_NONE = 0       # The screen is not faded at all.
FADE_STATE_BLACK = 255    # The screen is all black.

#Fade times in seconds, FADE_IN must be negative and FADE_OUT positive.
FADE_IN = -1.0
FADE_OUT = 1.0

#For the GUI
FONT_SIZE_BIG = 32
FONT_SIZE_SMALL = 18
COLOR_GUI = (200, 200, 200)
COLOR_GUI_HILIGHT = (250, 250, 250)
COLOR_GUI_DARK = (50, 50, 50)
COLOR_GUI_BG = (0, 0, 0)
COLOR_RED = (150, 0, 0)

#For the menu, used in menu.py:
MENU_QUIT = -1
MENU_MAX_VISIBLE = 10 #maximum amount of choices visible in the menu at one time
GUI_MENU_TOP = 75 #in pixels
#used as menu (in main game loop) return values
QUITTER = 'asdf'
MAIN_MENU = 'fdsa'

#How many old log lines are kept in the log file when the log is updated
MAX_OLD_LOG_LINES = 50

# Controls
KEYS = {
    K_UP:False,
    K_DOWN:False,
    K_LEFT:False,
    K_RIGHT:False
}

# psuedo rect selectors
LEFT, TOP, WIDTH, HEIGHT = 0, 1, 2, 3

# direction settings
U, D, L, R = 1, 2, 4, 8
UR, UL, DL, DR = U | R, U | L, D | L, D | R

TURN_LEFT = [U, UL, L, DL, D, DR, R, UR]
TURN_RIGHT = [U, UR, R, DR, D, DL, L, UL]

# easing
EASING = .15

# Character states
HOLD, WANDER, SEARCH, FOLLOW, ATTACK = 1, 2, 3, 4, 5

# gameplay modes
GAME_SURVIVAL, GAME_CUSTOM, GAME_NORMAL = 1, 2, 3

# Gameplay tweaks
LEVEL_OUT = 40 # level end wait frames
CONVERSION = 100
LIVES = 4
HP = 100
HERO_DMG = 2
ENEMY_DMG = 15
HERO_TANK = 'Tank7'


